import { IDType, DataObject, NewData, InvalidMessage, RESTClient } from './utility';
export declare abstract class BaseModel {
    downloading: number;
    uploading: number;
    clear(): this;
}
export declare abstract class BaseListModel<D extends DataObject> extends BaseModel {
    abstract client: RESTClient;
    abstract baseURI: string;
    currentOne: D;
    validity: InvalidMessage<D>;
    static createNested(parentId: IDType): BaseListModel<{}>;
    clear(): this;
    updateOne(data: NewData<D>, id?: IDType): Promise<D>;
    getOne(id: IDType): Promise<D>;
    removeOne(id: IDType): Promise<void>;
}
